Attribute VB_Name = "HighResIcon"
Option Explicit

'This cool code from Steve McMahon at:
' http://www.vbaccelerator.com/home/VB/Tips/Setting_the_App_Icon_Correctly/article.asp
' (slightly tweaked by RayOK)

Private Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long

Private Const IMAGE_ICON = 1

Private Const SM_CXICON = 11
Private Const SM_CYICON = 12

Private Const SM_CXSMICON = 49
Private Const SM_CYSMICON = 50
   
Private Declare Function LoadImageAsString Lib "user32" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpsz As String, ByVal uType As Long, ByVal cxDesired As Long, ByVal cyDesired As Long, ByVal fuLoad As Long) As Long
Private Const LR_SHARED = &H8000&

Private Declare Function SendMessageLong Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Const WM_SETICON = &H80

Private Const ICON_SMALL = 0
Private Const ICON_BIG = 1

Private Declare Function GetWindow Lib "user32" (ByVal hWnd As Long, ByVal wCmd As Long) As Long
Private Const GW_OWNER = 4

Public Sub SetIcon(ByVal hWnd As Long, ByVal sIconResName As String, Optional ByVal bSetAsAppIcon As Boolean = True)
    Dim lhWnd As Long, lhWndTop As Long, hIconSmall As Long, hIconLarge As Long
      
    hIconSmall = LoadImageAsString(App.hInstance, sIconResName, IMAGE_ICON, GetSystemMetrics(SM_CXSMICON), GetSystemMetrics(SM_CYSMICON), LR_SHARED)
    hIconLarge = LoadImageAsString(App.hInstance, sIconResName, IMAGE_ICON, GetSystemMetrics(SM_CXICON), GetSystemMetrics(SM_CYICON), LR_SHARED)
    
    SendMessageLong hWnd, WM_SETICON, ICON_SMALL, hIconSmall
    SendMessageLong hWnd, WM_SETICON, ICON_BIG, hIconLarge
    
    If bSetAsAppIcon Then
        ' Find VB's hidden parent window:
        lhWnd = hWnd
        lhWndTop = lhWnd
        Do While lhWnd <> 0
            lhWnd = GetWindow(lhWnd, GW_OWNER)
            If lhWnd <> 0 Then lhWndTop = lhWnd
        Loop
        
        SendMessageLong lhWndTop, WM_SETICON, ICON_SMALL, hIconSmall
        SendMessageLong lhWndTop, WM_SETICON, ICON_BIG, hIconLarge
    End If
End Sub
