VERSION 5.00
Begin VB.UserControl okGateway 
   ClientHeight    =   6120
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   9600
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ScaleHeight     =   408
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   640
   Begin VB.CommandButton cmdStop 
      Caption         =   "Stop selected listener"
      Enabled         =   0   'False
      Height          =   285
      Left            =   4800
      TabIndex        =   6
      Top             =   120
      Width           =   2175
   End
   Begin VB6_ISE.ucUpDownBox udbPort 
      Height          =   285
      Left            =   2400
      TabIndex        =   5
      Top             =   120
      Width           =   855
      _ExtentX        =   1508
      _ExtentY        =   503
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Min             =   1
      Max             =   65535
      Value           =   29999
   End
   Begin VB.TextBox txtIP 
      Height          =   285
      Left            =   480
      TabIndex        =   2
      Text            =   "127.0.0.1"
      Top             =   120
      Width           =   1215
   End
   Begin VB.CommandButton cmdListen 
      Caption         =   "Add listener"
      Height          =   285
      Left            =   3480
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
   Begin VB6_ISE.ucListView GatewayList 
      Height          =   4455
      Left            =   0
      TabIndex        =   0
      Top             =   510
      Width           =   9495
      _ExtentX        =   17171
      _ExtentY        =   5318
   End
   Begin VB.Label lblPort 
      Alignment       =   1  'Right Justify
      BackStyle       =   0  'Transparent
      Caption         =   "Port:"
      Height          =   255
      Left            =   1800
      TabIndex        =   4
      Top             =   165
      Width           =   495
   End
   Begin VB.Label lblIP 
      Alignment       =   1  'Right Justify
      BackStyle       =   0  'Transparent
      Caption         =   "IP:"
      Height          =   255
      Left            =   0
      TabIndex        =   3
      Top             =   165
      Width           =   375
   End
End
Attribute VB_Name = "okGateway"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private WithEvents GatewaySocket As okSocket
Attribute GatewaySocket.VB_VarHelpID = -1
Private WithEvents InSim As okInSimClient
Attribute InSim.VB_VarHelpID = -1

Private Enum GatewayColumns
    LIST_RECVSOCKET = 0
    LIST_RECVPORT = 1
    LIST_SENDSOCKET = 2
    LIST_SENDPORT = 3
    LIST_IP = 4
    LIST_STATUS = 5
    LIST_FLAGS = 6
    LIST_NS = 7
End Enum

Private m_intSelected As Integer    'index of the item that was last clicked, so the button can remove it

Public Sub Initialize()
    Set GatewaySocket = New okSocket
    
    If GatewaySocket.Initilize(UserControl.hWnd, g_Subclass) Then
        Set InSim = g_InSim
    Else
        'socket error
        Call Output("could not initilize gateway socket!?")
    End If
    
    With GatewayList
        Call .Initialize
        
        .BorderStyle = bsThin
        .HeaderFlat = True
        .ViewMode = vmDetails
        .FullRowSelect = True
        .RaiseSubItemPrePaint = True
        
        Call .ColumnAdd(LIST_RECVSOCKET, "Listen Socket", 80, caCenter)
        Call .ColumnAdd(LIST_RECVPORT, "Listen Port", 65, caCenter)
        Call .ColumnAdd(LIST_SENDSOCKET, "Reply Socket", 80, caCenter)
        Call .ColumnAdd(LIST_SENDPORT, "Reply Port", 65, caCenter)
        Call .ColumnAdd(LIST_IP, "IP", 110, caCenter)
        Call .ColumnAdd(LIST_STATUS, "Status", 200, caCenter)
        Call .ColumnAdd(LIST_FLAGS, "ISI Flags", 65, caCenter)
        Call .ColumnAdd(LIST_NS, "Node Secs", 65, caCenter)
    End With
    
    m_intSelected = -1
End Sub

Private Sub UserControl_Resize()
    On Error Resume Next
    
    Call GatewayList.Move(0, GatewayList.Top, UserControl.ScaleWidth, UserControl.ScaleHeight - GatewayList.Top)
End Sub

Private Sub udbPort_Change()
    Dim i As Long
    
    'disable the button if the port equals the insim or existing ports..
    cmdListen.Enabled = Not (udbPort.Value = InSim.RecvPort Or udbPort.Value = InSim.SendPort)
    
    For i = 0 To GatewayList.Count - 1
        If GatewayList.SubItemText(i, LIST_RECVPORT) = CStr(udbPort.Value) Then cmdListen.Enabled = False
    Next
End Sub

Private Sub cmdListen_Click()
    Dim lngSocket As Long, intIndex As Integer
    
    'add listener
    lngSocket = GatewaySocket.Listen(IPPROTO_UDP, udbPort.Value, txtIP.Text)
    
    'update list
    If lngSocket > 0 Then
        With GatewayList
            intIndex = .Count
            
            Call .ItemAdd(intIndex, CStr(lngSocket), 0, -1)
            Call .SubItemSet(intIndex, LIST_RECVPORT, CStr(udbPort.Value), -1)
            Call .SubItemSet(intIndex, LIST_IP, txtIP.Text, -1)
            Call .SubItemSet(intIndex, LIST_STATUS, "listening..", -1)
        End With
    Else
        Call Output("could not listen on this port/ip")
    End If
End Sub
Private Sub cmdStop_Click()
    Dim lngSocket As Long

    'if item > -1, stop then remove
    If m_intSelected > -1 Then
        lngSocket = CLng(Val(GatewayList.SubItemText(m_intSelected, LIST_RECVSOCKET)))
        If lngSocket Then Call GatewaySocket.CloseSocket(lngSocket)
        
        lngSocket = CLng(Val(GatewayList.SubItemText(m_intSelected, LIST_SENDSOCKET)))
        If lngSocket Then Call GatewaySocket.CloseSocket(lngSocket)
        
        Call GatewayList.ItemRemove(m_intSelected)
        
        m_intSelected = -1
        cmdStop.Enabled = (GatewayList.Count > 0) And (m_intSelected > -1)
    End If
End Sub

Private Sub GatewayList_OnSubItemPrePaint(ByVal Item As Integer, ByVal SubItem As Integer, TextBackColor As Long, TextForeColor As Long, Process As Boolean)
    If Item Mod 2 Then
        TextBackColor = RGB(240, 240, 240)
        Process = True
    End If
End Sub
Private Sub GatewayList_ItemClick(Item As Integer, Button As Integer)
    m_intSelected = Item
    cmdStop.Enabled = (m_intSelected > -1)
End Sub
Private Sub GatewayList_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    frmMain.MousePointer = 0
End Sub

Private Sub GatewaySocket_Error(ByVal lngSocket As Long, ByVal strMsg As String)
    Debug.Print "gateway socket error: " & strMsg
End Sub
Private Sub GatewaySocket_Received(ByVal lngSocket As Long, Data() As Byte, ByVal lngLength As Long)
    Dim bytData() As Byte, intIndex As Integer, lngSendSocket As Long, lngSendPort As Long, strID As String
    
    'find the socket
    intIndex = ConnectionFind(lngSocket)
    If intIndex > -1 Then
        'if accepted, filter for ISI port, then send to insim
        
        strID = UCase$(Left$(StrConv(Data, vbUnicode), 3))
        Select Case Left$(GatewayList.SubItemText(intIndex, LIST_STATUS), 9)
            Case "listening"
                If strID = "ISI" And lngLength = 24 Then
                    lngSendPort = Data(4) + (CLng(Data(5)) * 256)
                    
                    lngSendSocket = GatewaySocket.Connect(IPPROTO_UDP, lngSendPort, GatewayList.SubItemText(intIndex, LIST_IP))
                    If lngSendSocket Then
                        Call GatewayList.SubItemSet(intIndex, LIST_SENDSOCKET, CStr(lngSendSocket), -1)
                        Call GatewayList.SubItemSet(intIndex, LIST_SENDPORT, CStr(lngSendPort), -1)
                        Call GatewayList.SubItemSet(intIndex, LIST_STATUS, "connected", -1)
                        Call GatewayList.SubItemSet(intIndex, LIST_FLAGS, CStr(Data(6)), -1)
                        Call GatewayList.SubItemSet(intIndex, LIST_NS, CStr(Data(7)), -1)
                    Else
                        'error? could not connect back (first packet not ISI)
                        Call Output("could not connect back to gateway client")
                    End If
                Else
                    Call GatewayList.SubItemSet(intIndex, LIST_STATUS, "listening.. (packet not ISI?)", -1)
                End If
            Case "connected"
                If strID = "ISC" And lngLength = 8 Then
                    Call GatewaySocket.CloseSocket(CLng(Val(GatewayList.SubItemText(intIndex, LIST_SENDSOCKET))))
                    Call GatewayList.SubItemSet(intIndex, LIST_STATUS, "listening.. (closed)", -1)
                Else
                    ReDim bytData(0 To lngLength - 1)
                
                    'copy it over to hopefully release data buffer and therefore the socket?
                    Call CopyMemory(bytData(0), Data(0), lngLength)
                    Call InSim.DataSend(bytData)
                End If
            Case Else
                'error? close socket i guess
                Call GatewayList.SubItemSet(intIndex, LIST_STATUS, "error? closed..", -1)
                Call GatewaySocket.CloseSocket(lngSocket)
        End Select
    End If
End Sub
Private Sub GatewaySocket_Closed(ByVal lngSocket As Long)
    Dim i As Integer
    
    'find the socket
    For i = 0 To GatewayList.Count - 1
        If CLng(Val(GatewayList.SubItemText(i, LIST_RECVSOCKET))) = lngSocket Then Call GatewayList.SubItemSet(i, LIST_RECVSOCKET, "", -1)
        If CLng(Val(GatewayList.SubItemText(i, LIST_SENDSOCKET))) = lngSocket Then Call GatewayList.SubItemSet(i, LIST_SENDSOCKET, "", -1)
    Next
End Sub

Private Sub InSim_DataReceived(Bytes() As Byte, ByVal lngLength As Long)
    Dim intIndex As Integer, i As Integer, lngSendSocket As Long
    
    'cycle through all entries
    For i = 0 To GatewayList.Count - 1
        'if connected foward the data
        If Left$(GatewayList.SubItemText(i, LIST_STATUS), 9) = "connected" Then
            lngSendSocket = CLng(Val(GatewayList.SubItemText(i, LIST_SENDSOCKET)))
            If lngSendSocket Then Call GatewaySocket.Send(lngSendSocket, Bytes, 0)
        End If
    Next
End Sub

Private Function ConnectionFind(ByVal lngSocket As Long) As Long
    Dim intIndex As Integer, i As Integer

    intIndex = -1
    
    For i = 0 To GatewayList.Count - 1
        If GatewayList.SubItemText(i, LIST_RECVSOCKET) = CStr(lngSocket) Then
            intIndex = i
            Exit For
        End If
    Next
    
    ConnectionFind = intIndex
End Function
