VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "okInSimClient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'RayOK's VB6 InSim Client!
'
'To use you need 3 other items. First is LFS.bas with all the constants/enum/types you need. Next is my
'okSocket.cls (not the user control) and last item is a standard timer control. See Initilize to see the
'objects being assigned. This project probably includes the latest LFS.bas, okSocket.cls and an example
'how all this works..

'objects needed to work
Private WithEvents InSimSocket As okSocket
Attribute InSimSocket.VB_VarHelpID = -1
Private WithEvents theTimer As Timer
Attribute theTimer.VB_VarHelpID = -1

'sockets
Private m_lngInSimClient As Long      'internal socket of the insim client, LFS
Private m_lngInSimServer As Long      'internal socket of the insim server, us
Private m_blnInitilized As Boolean
Private m_blnConnected As Boolean     'connected or not
Private m_bytTimer As Byte            'timer count

'connection info
Private m_strInSimIP As String
Private m_lngInSimSendPort As Long
Private m_lngInSimRecvPort As Long
Private m_strInSimPassword As String
Private m_bytInSimFlags As Byte
Private m_bytNodeSeconds As Byte

Private m_lngOutSimInterval As Long
Private m_lngOutGaugeInterval As Long

'arrays to hold latest packet types
Private REOInfo(0 To 27) As PosId
Private NLPInfo(0 To 27) As NodeLap
Private MCIInfo(0 To 7) As CompCar

'ISI options for LFS
Private Const ISF_RACE_TRACKING As Byte = 1      'bit 0 turns on race tracking
Private Const ISF_GUARANTEE As Byte = 2          'bit 1 turns on guaranteed delivery
Private Const ISF_SPLIT_MESSAGE As Byte = 4      'bit 2 makes LFS use MSS for user messages instead of MSO
Private Const ISF_NO_WARNINGS As Byte = 8        'bit 3 turns off packet warnings
Private Const ISF_KEEP_ALIVE As Byte = 16        'bit 4 makes LFS send keep alive packets
Private Const ISF_NLP_MCI As Byte = 32           'bit 5 makes lfs send MCI instead of NLP

'events raised to update the UI n' stuff
Public Event Connected()
Public Event Disconnected()
Public Event Status(ByVal strMsg As String)

'event packets from InSim, base events
Public Event Version(ByVal strVersion As String, ByVal strProduct As String, ByVal lngInSimVer As Long)
Public Event Ack()
Public Event StateChanged(ByVal sngReplaySpeed As Single, ByVal lngStateFlags As Long, ByVal bytInGameCam As CameraViews, _
    ByVal bytViewPlayer As Byte, ByVal bytNumPlayers As Byte, ByVal bytNumConns As Byte, _
    ByVal bytNumFinished As Byte, ByVal bytRaceInProgress As Byte, ByVal bytQualMins As Byte, _
    ByVal bytRaceLaps As Byte, ByVal strTrack As String, ByVal bytWeather As Byte, ByVal Wind As Winds)
Public Event MultiJoin(ByVal bytHost As Byte, ByVal strName As String)
Public Event MultiLeave()
Public Event MessageOut(ByVal strMsg As String)
Public Event MessageSplit(ByVal strMsg As String, ByVal strLFSName As String, ByVal strPlyName As String)
Public Event VoteNotify(ByVal bytConn As Byte, ByVal Action As VoteActions)
Public Event VoteAction(ByVal Action As VoteActions)
Public Event VoteCancel()

'race tracking events
Public Event RaceStart(ByVal bytRaceLaps As Byte, ByVal bytQualMins As Byte, ByVal bytNumInRace As Byte, ByVal strTrack As String, ByVal bytWeather As Byte, _
    ByVal Wind As Winds, ByVal lngRaceFlags As Long)
Public Event RaceClear()
Public Event RaceReOrder(ByVal bytNumPlayers As Byte)
Public Event RaceEnd()
Public Event ConnectionNew(ByVal strLFSName As String, ByVal strPlyName As String, ByVal bytAdmin As Byte, ByVal bytConnNum As Byte, ByVal bytTotal As Byte)
Public Event ConnectionLeave(ByVal strLFSName As String, ByVal strPlyName As String, ByVal bytConnNum As Byte, ByVal bytTotal As Byte)
Public Event PlayerNew(ByVal strLFSName As String, ByVal strPlyName As String, _
    ByVal strPlate As String, ByVal strCarName As String, ByVal strSkinName As String, ByVal RLTyre As TyreCompounds, _
    ByVal RRTyre As TyreCompounds, ByVal FLTyre As TyreCompounds, ByVal FRTyre As TyreCompounds, ByVal lngPlayerFlags As Long, _
    ByVal bytType As Byte, ByVal bytUID As Byte, ByVal bytPlyNum As Byte, ByVal bytTotal As Byte)
Public Event PlayerSplit(ByVal sngSeconds As Single, ByVal bytPlyNum As Byte, ByVal bytUID As Byte, ByVal bytSplit As Byte)
Public Event PlayerLap(ByVal strLFSName As String, ByVal strPlyName As String, ByVal strCarName As String, ByVal lngLapsDone As Long, ByVal lngPlayerFlags As Long, _
    ByVal Penalty As PenaltyValue, ByVal bytNumStops As Byte, ByVal sngSeconds As Single, ByVal bytPlyNum As Byte, ByVal bytUID As Byte)
Public Event PlayerPitStop(ByVal lngLapsDone As Long, ByVal lngPlayerFlags As Long, ByVal Penalty As PenaltyValue, ByVal bytNumStops As Byte, _
    ByVal RLTyre As Byte, ByVal RRTyre As Byte, ByVal FLTyre As Byte, ByVal FRTyre As Byte, ByVal curPitWorkFlags As Currency, ByVal bytPlyNum As Byte, ByVal bytUID As Byte)
Public Event PlayerPitStopFinished(ByVal sngSeconds As Single, ByVal bytPlyNum As Byte, ByVal bytUID As Byte)
Public Event PlayerPitLane(ByVal Fact As PitLaneFacts, ByVal bytPlyNum As Byte, ByVal bytUID As Byte)
Public Event PlayerPenalty(ByVal OldPenalty As PenaltyValue, ByVal NewPenalty As PenaltyValue, ByVal bytPlyNum As Byte, ByVal bytUID As Byte)
Public Event PlayerTakeOverCar(ByVal strOldLFSName As String, ByVal strOldPlyName As String, _
    ByVal strNewLFSName As String, ByVal strNewPlyName As String, ByVal bytPlyNum As Byte, ByVal bytUID As Byte)
Public Event PlayerRaceFlag(ByVal blnOn As Boolean, ByVal Flag As RaceFlags, ByVal bytPlyNum As Byte, ByVal bytUID As Byte)
Public Event PlayerFlagChanged(ByVal lngFlags As Long, ByVal bytPlyNum As Byte, ByVal bytUID As Byte)
Public Event PlayerGarage(ByVal strLFSName As String, ByVal strPlyName As String, ByVal bytUID As Byte, ByVal bytPlyNum As Byte, ByVal bytTotal As Byte)
Public Event PlayerRename(ByVal strLFSName As String, ByVal strOldName As String, ByVal strNewName As String, ByVal strPlate As String, ByVal bytUID As Byte)
Public Event PlayerResult(ByVal strLFSName As String, ByVal strPlyName As String, ByVal strPlate As String, _
    ByVal strCarName As String, ByVal lngHours As Long, ByVal lngLapsDone As Long, ByVal lngFlags As Long, ByVal bytConfirmFlags As Byte, _
    ByVal bytNumStops As Byte, ByVal bytType As Byte, ByVal bytUID As Byte, ByVal sngTotalTime As Single, _
    ByVal sngBestLap As Single, ByVal bytResultNum As Byte, ByVal bytNumResults As Byte)
Public Event PlayerLeave(ByVal strLFSName As String, ByVal strPlyName As String, ByVal bytUID As Byte, ByVal bytPlyNum As Byte, ByVal bytTotal As Byte)
Public Event NodeLap(ByVal lngNumNodes As Long, ByVal lngFinishNode As Long, ByVal bytNumPlayers As Byte)
Public Event MultiCarInfo(ByVal lngNumNodes As Long, ByVal lngFinishNode As Long, ByVal bytNumPlayers As Byte, ByVal bytFirstPly As Byte)

'camera and time events
Public Event CameraPosition(ByVal lngVecX As Long, ByVal lngVecY As Long, ByVal lngVecZ As Long, _
    ByVal lngHeading As Long, ByVal lngPitch As Long, ByVal lngRoll As Long, ByVal bytViewPlayer As Byte, ByVal bytInGameCam As CameraViews, _
    ByVal sngFOV As Single, ByVal lngTime As Long, ByVal lngStateFlags As Long)
Public Event RaceTime(ByVal lngTime As Long)

'outsim and outgauge events
Public Event OutSim(Data() As Byte)
Public Event OutGauge(Data() As Byte)

'pure receive data event, for the gateway..
Public Event DataReceived(Bytes() As Byte, ByVal lngLength As Long)

Public Function Initilize(ByVal aSocket As okSocket, aTimer As Timer) As Boolean
    If Not m_blnInitilized Then
        Set InSimSocket = aSocket
        Set theTimer = aTimer
    
        m_blnInitilized = True
    End If

    Initilize = m_blnInitilized
End Function

Public Sub Terminate()
    If m_blnConnected Then Call Disconnect
    m_blnInitilized = False
End Sub

'properties
Public Property Get Connected() As Boolean
    Connected = m_blnConnected
End Property

Public Property Get SendPort() As Long
    SendPort = m_lngInSimSendPort
End Property

Public Property Get RecvPort() As Long
    RecvPort = m_lngInSimRecvPort
End Property

Public Property Get OutSimInterval() As Long
    OutSimInterval = m_lngOutSimInterval
End Property
'To request Car Positions from the currently viewed car, send this InSimPack :
'
'Id  : "SSP" - Start Sending Positions (sends UDP packets using OutSim system)
'Value   : delay between updates (zero means stop sending)
Public Property Let OutSimInterval(ByVal lngInterval As Long)
    Call SendISP("SSP", lngInterval)
    m_lngOutSimInterval = lngInterval
End Property

Public Property Get OutGaugeInterval() As Long
    OutGaugeInterval = m_lngOutGaugeInterval
End Property
'To request Dashboard Packets from the currently viewed car, send this InSimPack :
'
'Id  : "SSG" - Start Sending Gauges (sends UDP packets using OutGauge system)
'Value   : delay between updates (zero means stop sending)
Public Property Let OutGaugeInterval(ByVal lngInterval As Long)
    Call SendISP("SSG", lngInterval)
    m_lngOutGaugeInterval = lngInterval
End Property

'- InSim connect/disconnect control
Public Sub Connect(ByVal strIP As String, ByVal lngSendPort As Long, ByVal lngRecvPort As Long, ByVal strPassword As String, _
    Optional ByVal RaceTracking As Boolean = True, Optional SplitMessages As Boolean = True, Optional MCINotNLP As Boolean = True, Optional Seconds As Byte)
    If Not m_blnConnected Then
        m_strInSimIP = strIP
        m_lngInSimSendPort = lngSendPort
        m_lngInSimRecvPort = lngRecvPort
        m_strInSimPassword = strPassword
        m_bytInSimFlags = ISF_GUARANTEE Or ISF_KEEP_ALIVE Or -RaceTracking * ISF_RACE_TRACKING Or -SplitMessages * ISF_SPLIT_MESSAGE Or -MCINotNLP * ISF_NLP_MCI
        m_bytNodeSeconds = Seconds
        
        m_lngInSimServer = InSimSocket.Listen(IPPROTO_UDP, IIf(m_lngInSimRecvPort = 0, m_lngInSimSendPort, m_lngInSimRecvPort))
        If m_lngInSimServer Then
            m_lngInSimClient = InSimSocket.Connect(IPPROTO_UDP, m_lngInSimSendPort, m_strInSimIP)
            If m_lngInSimClient Then
                m_bytTimer = 0              'start the timer to connect/keep alive
                theTimer.Interval = 1000
                theTimer.Enabled = True
            Else
                RaiseEvent Status("could not create client socket!")
                Call InSimSocket.CloseSocket(m_lngInSimServer)
            End If
        Else
            RaiseEvent Status("could not create server socket!")
        End If
    Else
        RaiseEvent Status("already connected!?")
    End If
End Sub

'You can send a packet to ask InSim to return to its waiting / initialised / listening
'state by sending an InSimPack with Id = "ISC" (InSimClose) and Value = 0.
Public Function Disconnect()
    m_bytTimer = 0
    theTimer.Enabled = False
    
    If m_blnConnected Then
        m_blnConnected = False
        
        Call SendISP("ISC")
        Call InSimSocket.CloseSocket(m_lngInSimServer)
        Call InSimSocket.CloseSocket(m_lngInSimClient)
    
        RaiseEvent Disconnected
    End If
End Function

'struct MsgTypePack // 64 chars - send to LFS to simulate typing message or command
'{
'    char    Id  [4];    // MST + zero
'    char    Msg [64];   // text message or /command, must end with zero
'};
Public Sub SendMessage(ByVal strMsg As String)
    Dim bytData(0 To 67) As Byte
    
    Call StringToBytes(bytData, "MST", 0, 3)
    Call StringToBytes(bytData, strMsg, 4, 63)
    
    Call InSimSocket.Send(m_lngInSimClient, bytData, 0)
End Sub

'struct MsgToConn // 64 chars - send to LFS and on to a chosen connection (0 = host)
'{
'    char    Id  [4];    // MTC + zero
'    byte    Conn;       // connection
'    byte    UniqueId;   // destination player UniqueId : if set, Conn is ignored
'    byte    Sp2;
'    byte    Sp3;
'    char    Msg [64];   // text message or /command, must end with zero
'};
Public Sub SendPlayerMessage(ByVal strMsg As String, Optional ByVal bytUniqueID As Byte, Optional ByVal bytConnNum As Byte)
    Dim bytData(0 To 71) As Byte
    
    Call StringToBytes(bytData, "MTC", 0, 3)
    bytData(4) = bytConnNum
    bytData(5) = bytUniqueID
    Call StringToBytes(bytData, strMsg, 8, 63)
    
    Call InSimSocket.Send(m_lngInSimClient, bytData, 0)
End Sub

'struct SingleCharPack // send to LFS to simulate single character
'{
'    char    Id  [4];    // SCH + zero
'    char    Char;       // key to press
'    byte    Flags;      // bit 0 : SHIFT / bit 1 : CTRL
'    byte    Spare2;
'    byte    Spare3;
'};
Public Sub SendChar(ByVal bytChar As Byte, Optional ByVal CtrlOrShift As CtrlShift = SCH_NONE)
    Dim bytData(0 To 7) As Byte
    
    Call StringToBytes(bytData, "SCH", 0, 3)
    bytData(4) = bytChar
    bytData(5) = CtrlOrShift
    
    Call InSimSocket.Send(m_lngInSimClient, bytData, 0)
End Sub

'struct StateFlagsPack
'{
'    char    Id  [4];    // SFP + zero
'    word    Flag;       // the state to set (ISS_xxx)
'    byte    OffOn;      // 0 = off / 1 = on
'    byte    Sp3;        // spare
'};
Public Sub SetState(ByVal WhichState As SettableStates, ByVal TurnOn As Boolean)
    Dim bytData(0 To 7) As Byte
    
    Call StringToBytes(bytData, "SFP", 0, 3)
    Call LongToWordBytes(bytData, WhichState, 4)
    bytData(6) = -TurnOn
    
    Call InSimSocket.Send(m_lngInSimClient, bytData, 0)
End Sub

'struct InSimMode
'{
'    char    Id  [4];    // MOD + zero (MODe)
'    int Bits16;     // set to choose 16-bit mode
'    int RR;     // refresh rate - zero for default
'    int Width;      // 0 - go to window
'    int Height;     // 0 - go to window
'};
Public Sub SetScreenMode(Optional ByVal Bits16 As Boolean, Optional ByVal Refresh As Long, _
                         Optional ByVal Width As Long, Optional ByVal Height As Long)
    Dim bytData(0 To 19) As Byte
    
    Call StringToBytes(bytData, "MOD", 0, 3)
    bytData(4) = -Bits16    'i guess
    Call CopyMemory(bytData(8), Refresh, 4)     'VB6 long to C++ int, same thing, just copy
    Call CopyMemory(bytData(12), Width, 4)
    Call CopyMemory(bytData(16), Height, 4)
    
    Call InSimSocket.Send(m_lngInSimClient, bytData, 0)
End Sub

'The external program can instruct LFS host to cancel a vote using an InSimPack
'
'Id  : "VTC"     (VoTe Cancel)
'Value   : 0
Public Sub CancelVote()
    Call SendISP("VTC")
End Sub

'To request an InSimVersion packet, send an InSimPack like this :
'
'Id  : "VER"  (VERsion)
'Value   : 0
Public Sub GetVersion()
    Call SendISP("VER")
End Sub

'To request a StatePack from LFS, send an InSimPack like this :
'--------------------------------------------------------------
'Id  : "SST"  (Send State)
'Value   : 0
Public Sub GetState()
    Call SendISP("SST")
End Sub

'To request a InSimMulti packet at any time, send a InSimPack with Id = "ISM".
'- If LFS is not in multiplayer mode, the host name in the ISM will be empty.
Public Sub GetMulti()
    Call SendISP("ISM")
End Sub

'TRACKING PACKET REQUESTS
'------------------------
'- send to LFS to request player / connection / result packets
'- these requests work even if race tracking is not switched on
'
'To request a IS_RES, send a InSimPack with Id = "RES" and value = result number (0,1,2...)
Public Sub GetPlayerResult(ByVal lngResultNum As Long)
    Call SendISP("RES", lngResultNum)
End Sub
'To request a IS_NPL, send a InSimPack with Id = "NPL" and value = player number (0,1,2...)
Public Sub GetPlayerNew(ByVal lngPlayerNum As Long)
    Call SendISP("NPL", lngPlayerNum)
End Sub
'To request a IS_NCN, send a InSimPack with Id = "NCN" and value = conn number (0,1,2...)
Public Sub GetConnectionNew(ByVal lngConnNum As Long)
    Call SendISP("NCN", lngConnNum)
End Sub
'To request a IS_NLP, send a InSimPack with Id = "NLP" and value = 0
Public Sub GetNodeLap()
    Call SendISP("NLP")
End Sub
'To request a IS_MCI, send a InSimPack with Id = "MCI" and value = 0
Public Sub GetMultiCarInfo()
    Call SendISP("MCI")
End Sub

'You can change the rate of NLP or MCI after initialisation by sending this InSimPack :
'
'Id  : "NLI"         (Node Lap Interval)
'Value   : Interval      (0 means stop, otherwise interval in milliseconds, minimum 100)
Public Sub SetNodeLapInterval(ByVal lngMillseconds As Long)
    If lngMillseconds > 0 And lngMillseconds < 100 Then lngMillseconds = 100
    Call SendISP("NLI", lngMillseconds)
End Sub

'These next 3 are supposed to be called when you receive the corresponding packet.
'Since VB6 cannot pass an array of UDTs (user-defined types) in a public event, the latest
'packet info is stored locally and can be returned using these friend functions below..
'For example, when a MultiCarInfo event is received you would call GetMCIInfo immediately
'to get the CompCar data that was supposed to be in the MultiCarInfo event. Like this:
'
'Private Sub InSim_MultiCarInfo(ByVal lngNumNodes As Long, ByVal lngFinishNode As Long, ByVal bytNumPlayers As Byte, ByVal bytFirstPly As Byte)
'   Dim currentCompCar As CompCar(), i As Integer
'
'   currentCompCar = InSim.GetMCIInfo
'   For i = LBound(currentCompCar) To UBound(currentCompCar)
'       'manipulate currentCompCar(i)
'   Next
'End Sub
Friend Function GetREOInfo() As PosId()
    GetREOInfo = REOInfo
End Function

Friend Function GetNLPInfo() As NodeLap()
    GetNLPInfo = NLPInfo
End Function

Friend Function GetMCIInfo() As CompCar()
    GetMCIInfo = MCIInfo
End Function

'struct SetCarCamera     // Simplified camera packet (not SHIFT+U mode)
'{
'    char    Id  [4];    // SCC + zero
'    byte    ViewPlayer; // Player Index of car to view (0 = pole...)
'    byte    InGameCam;  // InGameCam (as reported in StatePack)
'    byte    UniqueId;   // Overrides ViewPlayer if set
'    byte    Spare3;
'};
Public Sub SetCamera(Optional ByVal bytViewPlayer As Byte = 255, Optional ByVal bytCamera As CameraViews = 255, Optional bytUniqueID As Byte)
    Dim bytData(0 To 7) As Byte
    
    Call StringToBytes(bytData, "SCC", 0, 3)
    bytData(4) = bytViewPlayer
    bytData(5) = bytCamera
    bytData(6) = bytUniqueID
    
    Call InSimSocket.Send(m_lngInSimClient, bytData, 0)
End Sub

'struct CamPosPack       // Full camera packet (in game OR SHIFT+U mode)
'{
'    char    Id  [4];    // CPP + zero
'    Vec Pos;        // Position vector
'    word    Heading;    // 0 points along Y axis
'    word    Pitch;      // 0 means looking at horizon
'    word    Roll;       // 0 means no roll
'    byte    ViewPlayer; // Player Index of car to view (0 = pole...)
'    byte    InGameCam;  // InGameCam (as reported in StatePack)
'    float   FOV;        // 4-byte float : FOV in radians
'    word    Time;       // Time to get there (0 means instant + reset)
'    word    Flags;      // State Flags
'}
Public Sub SetCameraPosition(ByVal lngVecX As Long, ByVal lngVecY As Long, ByVal lngVecZ As Long, _
    ByVal lngHeading As Long, ByVal lngPitch As Long, ByVal lngRoll As Long, ByVal bytViewPlayer As Byte, _
    ByVal bytInGameCam As CameraViews, ByVal sngFOV As Single, ByVal lngTime As Long, ByVal lngFlags As Long)
    
    Dim bytData(0 To 31) As Byte
    
    Call StringToBytes(bytData, "CPP", 0, 3)
    Call CopyMemory(bytData(4), lngVecX, 4)
    Call CopyMemory(bytData(8), lngVecY, 4)
    Call CopyMemory(bytData(12), lngVecZ, 4)
    Call LongToWordBytes(bytData, lngHeading, 16)
    Call LongToWordBytes(bytData, lngPitch, 18)
    Call LongToWordBytes(bytData, lngRoll, 20)
    bytData(22) = bytViewPlayer
    bytData(23) = bytInGameCam
    Call CopyMemory(bytData(24), sngFOV, 4)
    Call LongToWordBytes(bytData, lngTime, 28)
    Call LongToWordBytes(bytData, lngFlags, 30)
    
    Call InSimSocket.Send(m_lngInSimClient, bytData, 0)
End Sub

'To GET a CamPosPack from LFS, send an InSimPack like this :
'
'Id  : "SCP"  (Send Camera Pos)
'Value   : 0
Public Sub GetCameraPosition()
    Call SendISP("SCP")
End Sub

'Stop and Start with an InSimPack like this :
'
'Id  : "TMS"  (Time Stop)
'Value   : 1 - stop / 0 - carry on
Public Sub TimeStop(ByVal blnStopped As Boolean)
    Call SendISP("TMS", CLng(-blnStopped))
End Sub

'When STOPPED, make time step updates with this InSimPack :
'
'Id  : "STP"  (Time Step)
'Value   : 1, 2, 3, 4 etc, number of hundredths of a second to update
Public Sub TimeStep(ByVal lngHundreths As Long)
    Call SendISP("STP", lngHundreths)
End Sub

'Request the current time at any point with this InSimPack :
'
'Id  : "GTH"  (Get Time in Hundredths)
'Value   : 0
Public Sub GetRaceTime()
    Call SendISP("GTH")
End Sub

'for gateway programs to send raw data
Public Sub DataSend(Data() As Byte)
    Dim strID As String
    
    If m_blnConnected Then
        'filter for ISI and ISC packets
        strID = UCase$(BytesToString(Data, 0, 3))
        
        If strID = "ISI" Or strID = "ISC" Then
            'dont send these
        Else
            Call InSimSocket.Send(m_lngInSimClient, Data, 0)
        End If
    End If
End Sub

'struct InSimInit        // UDP packet to initialise the InSim system
'{
'    char    Id  [4];    // ISI + zero
'    word    Port;       // Port for UDP replies from LFS (0...65535)
'    byte    Flags;      // Bit flags for options - see below
'    byte    NodeSecs;   // Number of seconds between NLP or MCI packets (0=none)
'    char    Admin   [16];   // Admin password (required if set in LFS host options)
'};
Private Sub SendISI()
    Dim bytData(0 To 23) As Byte
    
    Call StringToBytes(bytData, "ISI", 0, 3)
    Call LongToWordBytes(bytData, m_lngInSimRecvPort, 4)
    bytData(6) = m_bytInSimFlags
    bytData(7) = m_bytNodeSeconds
    Call StringToBytes(bytData, m_strInSimPassword, 8, 16)
    
    Call InSimSocket.Send(m_lngInSimClient, bytData, 0)
End Sub

'InSimPack is used for various InSim requests (see below)
'
'struct InSimPack        // General purpose 8 byte UDP packet
'{
'    char    Id  [4];    // 3 character identifier followed by zero character
'    int Value;      // 32 bit value depending on the type of InSimPack
'};
Private Sub SendISP(ByVal strID As String, Optional ByVal lngValue As Long)
    Dim bytData(0 To 7) As Byte
    
    Call StringToBytes(bytData, strID, 0, 3)
    Call LongToWordBytes(bytData, lngValue, 4)
    
    Call InSimSocket.Send(m_lngInSimClient, bytData, 0)
End Sub

'timer to connect and for a keep alive
Private Sub theTimer_Timer()
    If Not m_blnConnected Then       'send a VER packet every 10 seconds, 3 times
        If m_bytTimer = 30 Then
            RaiseEvent Status("no response in 3 tries.. InSim running?")
            Call Disconnect
            Exit Sub
        ElseIf m_bytTimer Mod 10 = 0 Then
            RaiseEvent Status("connecting to " & m_strInSimIP & ":" & CStr(m_lngInSimSendPort) & " (" & m_bytTimer \ 10 + 1 & "/3 tries)")
            
            Call SendISI
            Call GetVersion
        End If
    Else
        'send ACK every 30 seconds for a keep alive
        If m_bytTimer Mod 30 = 0 Then
            Call SendISP("ACK")
        End If

        'if no ack's in 2 mins, disconnect
        If m_bytTimer > 120 Then
            RaiseEvent Status("no response in 2 minutes.. InSim running?")
            Call Disconnect
        End If
    End If
    
    m_bytTimer = m_bytTimer + 1
    If m_bytTimer >= 240 Then m_bytTimer = 1    'avoid overflow..
End Sub

'- socket events
'
Private Sub InSimSocket_Error(ByVal lngSocket As Long, ByVal strMsg As String)
    Debug.Print "insim " & _
        IIf(lngSocket = m_lngInSimClient, "client", IIf(lngSocket = m_lngInSimServer, "server", "unknown")) & _
        " socket error: " & strMsg
End Sub
Private Sub InSimSocket_Received(ByVal lngSocket As Long, Data() As Byte, ByVal lngLength As Long)
    If lngSocket = m_lngInSimServer Then
        m_bytTimer = 0        'reset timeout
        
        RaiseEvent DataReceived(Data, lngLength)

        If Not m_blnConnected Then   'now connected
            m_blnConnected = True

            RaiseEvent Status("connected to " & m_strInSimIP & ":" & CStr(m_lngInSimSendPort))
            RaiseEvent Connected

            'get state and host info
            Call GetState
            Call GetMulti
        End If
        
        'Debug.Print "received: " & BytesToString(Data, 0, 3)
        
        'parse packet depending on ID
        Select Case BytesToString(Data, 0, 3)
            Case "VER"
                Dim lngVersion As Long
                
                lngVersion = BytesWordToLong(Data, 18)
                If lngVersion < 3 Then RaiseEvent Status("InSim version is less than 3. Get LFS S2 V5 or later!")
                RaiseEvent Version(BytesToString(Data, 4, 8), BytesToString(Data, 12, 6), lngVersion)
            Case "ACK"
                RaiseEvent Ack
            Case "STA"
                RaiseEvent StateChanged(BytesFloatToSingle(Data, 4), BytesWordToLong(Data, 8), Data(10), Data(11), Data(12), _
                    Data(13), Data(14), Data(15), Data(16), Data(17), BytesToString(Data, 20, 6), Data(26), Data(27))
            Case "MSO"          'MeSsageOut, LFS reporting displayed messages
                RaiseEvent MessageOut(BytesToString(Data, 4, 128))
            Case "MSS"          'MeSsageSplit, user messages if ISF_SPLIT_MESSAGE flag is ON
                RaiseEvent MessageSplit(BytesToString(Data, 52, 64), BytesToString(Data, 4, 24), BytesToString(Data, 28, 24))
            Case "ISM"          'InSimMulti, when a host is started or joined
                RaiseEvent MultiJoin(Data(4), BytesToString(Data, 8, 32))
            Case "MPE"          'MultiPlayerEnd, on ending or leaving a host
                RaiseEvent MultiLeave
            Case "VTN"          'VoTeNotify, votes to restart or qualify
                RaiseEvent VoteNotify(Data(4), Data(5))
            Case "VTA"          'VoTeAction, when a vote is completed
                RaiseEvent VoteAction(Data(4))
            Case "VTC"          'VoTeCancel, when a vote is cancelled (can be sent as ISP to cancel)
                RaiseEvent VoteCancel
            Case "RST"          'Race STart
                Call SendISP("ACK", BytesWordToLong(Data, 18))
                RaiseEvent RaceStart(Data(4), Data(5), Data(6), BytesToString(Data, 8, 6), Data(14), Data(15), BytesWordToLong(Data, 16))
            Case "CLR"          'CLear Race
                Call SendISP("ACK", BytesWordToLong(Data, 6))
                RaiseEvent RaceClear
            Case "REO"          'REOrder
                Call SendISP("ACK", BytesWordToLong(Data, 63))
                Call DoRaceReOrder(Data)
            Case "REN"          'Race ENd
                Call SendISP("ACK", BytesWordToLong(Data, 6))
                RaiseEvent RaceEnd
            Case "NCN"          'New CoNnection
                Call SendISP("ACK", BytesWordToLong(Data, 58))
                RaiseEvent ConnectionNew(BytesToString(Data, 4, 24), BytesToString(Data, 28, 24), Data(52), Data(56), Data(57))
            Case "CNL"          'CoNnection Leave
                Call SendISP("ACK", BytesWordToLong(Data, 54))
                RaiseEvent ConnectionLeave(BytesToString(Data, 4, 24), BytesToString(Data, 28, 24), Data(52), Data(53))
            Case "NPL"          'New PLayer joining race, if number already there, leaving pits
                Call SendISP("ACK", BytesWordToLong(Data, 98))
                RaiseEvent PlayerNew(BytesToString(Data, 4, 24), BytesToString(Data, 28, 24), BytesToString(Data, 52, 8), BytesToString(Data, 60, 4), _
                    BytesToString(Data, 64, 16), Data(80), Data(81), Data(82), Data(83), BytesWordToLong(Data, 92), Data(94), Data(95), Data(96), Data(97))
            Case "SP1", "SP2", "SP3"    'SPlit X time
                Call SendISP("ACK", BytesWordToLong(Data, 10))
                RaiseEvent PlayerSplit(BytesMSHTToSeconds(Data, 4), Data(8), Data(9), Val(Chr(Data(2))))
            Case "LAP"          'LAP time
                Call SendISP("ACK", BytesWordToLong(Data, 90))
                RaiseEvent PlayerLap(BytesToString(Data, 4, 24), BytesToString(Data, 28, 24), BytesToString(Data, 52, 4), BytesWordToLong(Data, 56), _
                    BytesWordToLong(Data, 58), Data(60), Data(61), BytesMSHTToSeconds(Data, 84), Data(88), Data(89))
            Case "PIT"          'PIT stop (stop at pit garage)
                Dim curPitWork As Currency
                
                curPitWork = Data(16) + (CCur(Data(17)) * 256) + (CCur(Data(18)) * 65536) + (CCur(Data(19)) * 16777216)
                
                Call SendISP("ACK", BytesWordToLong(Data, 26))
                RaiseEvent PlayerPitStop(BytesWordToLong(Data, 4), BytesWordToLong(Data, 6), Data(8), Data(9), Data(12), Data(13), Data(14), Data(15), curPitWork, Data(24), Data(25))
            Case "PSF"          'Pit Stop Finished
                Call SendISP("ACK", BytesWordToLong(Data, 14))
                RaiseEvent PlayerPitStopFinished(BytesMSHTToSeconds(Data, 4), Data(12), Data(13))
            Case "PLA"          'Pit LAne
                Call SendISP("ACK", BytesWordToLong(Data, 10))
                RaiseEvent PlayerPitLane(Data(4), Data(8), Data(9))
            Case "PEN"          'PENalty (given or cleared)
                Call SendISP("ACK", BytesWordToLong(Data, 10))
                RaiseEvent PlayerPenalty(Data(4), Data(5), Data(8), Data(9))
            Case "TOC"          'Take Over Car
                Call SendISP("ACK", BytesWordToLong(Data, 102))
                RaiseEvent PlayerTakeOverCar(BytesToString(Data, 4, 24), BytesToString(Data, 28, 24), BytesToString(Data, 52, 24), BytesToString(Data, 76, 24), Data(100), Data(101))
            Case "FLG"          'FLaG (yellow or blue flag changed)
                Call SendISP("ACK", BytesWordToLong(Data, 10))
                RaiseEvent PlayerRaceFlag(Data(4), Data(5), Data(8), Data(9))
            Case "PFL"          'Player FLags (help flags changed)
                Call SendISP("ACK", BytesWordToLong(Data, 10))
                RaiseEvent PlayerFlagChanged(BytesWordToLong(Data, 4), Data(8), Data(9))
            Case "PLP"          'PLayer Pits
                Call SendISP("ACK", BytesWordToLong(Data, 58))
                RaiseEvent PlayerGarage(BytesToString(Data, 4, 24), BytesToString(Data, 28, 24), Data(52), Data(56), Data(57))
            Case "CPR"          'Connection Player Rename
                Call SendISP("ACK", BytesWordToLong(Data, 85))
                RaiseEvent PlayerRename(BytesToString(Data, 4, 24), BytesToString(Data, 28, 24), BytesToString(Data, 52, 24), BytesToString(Data, 76, 8), Data(84))
            Case "RES", "FIN"   'RESult, qualify or finish
                Call SendISP("ACK", BytesWordToLong(Data, 106))
                RaiseEvent PlayerResult(BytesToString(Data, 4, 24), BytesToString(Data, 28, 24), BytesToString(Data, 52, 8), BytesToString(Data, 60, 4), _
                    BytesWordToLong(Data, 84), BytesWordToLong(Data, 88), BytesWordToLong(Data, 90), Data(92), Data(93), Data(94), Data(95), _
                    BytesMSHTToSeconds(Data, 96), BytesMSHTToSeconds(Data, 100), Data(104), Data(105))
            Case "PLL"          'PLayer Leave race, spectate
                Call SendISP("ACK", BytesWordToLong(Data, 58))
                RaiseEvent PlayerLeave(BytesToString(Data, 4, 24), BytesToString(Data, 28, 24), Data(52), Data(56), Data(57))
            Case "NLP"          'Node and Lap Packet, only nodes
                Call DoNodeLap(Data)
            Case "MCI"          'MultiCarInfo, nodes and position/telemetry
                Call DoMultiCarInfo(Data)
            Case "CPP"          'Camera Position Packet
                RaiseEvent CameraPosition(BytesIntToLong(Data, 4), BytesIntToLong(Data, 8), BytesIntToLong(Data, 12), BytesWordToLong(Data, 16), BytesWordToLong(Data, 18), _
                    BytesWordToLong(Data, 20), Data(22), Data(23), BytesFloatToSingle(Data, 24), BytesWordToLong(Data, 28), BytesWordToLong(Data, 30))
            Case "RTP"          'Race Time Packet
                RaiseEvent RaceTime(BytesIntToLong(Data, 4))
            Case Else
                'check if outsim or outgauge
                If lngLength = 64 And Data(3) = 0 Then 'outsim packet
                    RaiseEvent OutSim(Data)
                ElseIf lngLength = 92 And Data(3) = 0 Then 'outgauge packet
                    RaiseEvent OutGauge(Data)
                Else
                    RaiseEvent Status("Unknown packet!? (" & BytesToString(Data, 0, 3) & ")")
                End If
        End Select
    End If
End Sub

'actions depending on the packet received
Private Sub DoRaceReOrder(Data() As Byte)
    Dim i As Byte, bytInfo As Byte
    
    For i = 0 To 27
        bytInfo = 5 + (i * 2)
        
        With REOInfo(i)
            .bytOldPos = Data(bytInfo)
            .bytUniqueID = Data(bytInfo + 1)
        End With
    Next i

    RaiseEvent RaceReOrder(Data(62))
End Sub

Private Sub DoNodeLap(Data() As Byte)
    Dim i As Byte, bytInfo As Byte
    
    For i = 0 To 27
        bytInfo = 12 + (i * 4)

        With NLPInfo(i)
            .lngNode = BytesWordToLong(Data, bytInfo) And 8191
            .lngLap = Data(bytInfo + 2) Or ((BytesWordToLong(Data, bytInfo) And 57344) \ 8192)
            .bytUID = Data(bytInfo + 3)
        End With
    Next i
    
    RaiseEvent NodeLap(BytesWordToLong(Data, 4), BytesWordToLong(Data, 6), Data(8))
End Sub

Private Sub DoMultiCarInfo(Data() As Byte)
    Dim i As Byte, bytInfo As Byte
    
    For i = 0 To 7
        bytInfo = 12 + (i * 24)

        With MCIInfo(i)
            .lngNode = BytesWordToLong(Data, bytInfo) And 8191
            .lngLap = Data(bytInfo + 2) Or ((BytesWordToLong(Data, bytInfo) And 57344) \ 8192)
            .bytUID = Data(bytInfo + 3)
            .lngX = BytesIntToLong(Data, bytInfo + 4)
            .lngY = BytesIntToLong(Data, bytInfo + 8)
            .lngZ = BytesIntToLong(Data, bytInfo + 12)
            .lngSpeed = BytesWordToLong(Data, bytInfo + 16)
            .lngDirection = BytesWordToLong(Data, bytInfo + 18)
            .lngHeading = BytesWordToLong(Data, bytInfo + 20)
            Call CopyMemory(.intAngVel, Data(bytInfo + 22), 2)    'C++ short to VB6 integer, both 2 byte signed, so just copy
        End With
    Next i
    
    RaiseEvent MultiCarInfo(BytesWordToLong(Data, 4), BytesWordToLong(Data, 6), Data(8), Data(9))
End Sub

'helper functions to convert InSim data one way or another
Private Sub StringToBytes(bytData() As Byte, ByVal strString As String, ByVal intStart As Integer, ByVal intLength As Integer)
    Dim i As Integer
    
    On Error GoTo StringToBytesErr
    
    For i = 1 To intLength
        bytData(intStart - 1 + i) = Asc(Mid$(strString, i, 1))
    Next
    
StringToBytesErr:
    'silent error, for now
End Sub

Private Sub LongToWordBytes(bytData() As Byte, ByVal lngWord As Long, ByVal intStart As Integer)
    bytData(intStart) = lngWord Mod 256
    bytData(intStart + 1) = lngWord \ 256
End Sub

Private Function BytesToString(bytData() As Byte, ByVal intStart As Integer, ByVal intLength As Integer) As String
    Dim i As Integer, strString As String
    
    'copy the bytes
    For i = 0 To intLength - 1
        If bytData(intStart + i) = 0 Then
            Exit For
        Else
            strString = strString & Chr$(bytData(intStart + i))
        End If
    Next i
    
    'remove lfs codes, colors first
    For i = 0 To 9
        strString = Replace(strString, "^" & i, "")
    Next i
    
    'special LFS characters
    strString = Replace(strString, "^a", "*")
    strString = Replace(strString, "^c", ":")
    strString = Replace(strString, "^d", "\")
    strString = Replace(strString, "^l", "<")
    strString = Replace(strString, "^q", "?")
    strString = Replace(strString, "^r", ">")
    strString = Replace(strString, "^s", "/")
    strString = Replace(strString, "^t", """")  'double quote
    strString = Replace(strString, "^v", "|")
    
    'language codes
    strString = Replace(strString, "^L", "")    'Latin 1
    strString = Replace(strString, "^G", "")    'Greek
    strString = Replace(strString, "^C", "")    'Cyrillic
    strString = Replace(strString, "^J", "")    'Japanese
    strString = Replace(strString, "^E", "")    'Central Europe
    strString = Replace(strString, "^T", "")    'Turkish
    strString = Replace(strString, "^B", "")    'Baltic
    
    BytesToString = strString
End Function

'convert from a C++ word in a byte array to a long
Private Function BytesWordToLong(bytData() As Byte, ByVal intStart As Integer) As Long
    BytesWordToLong = bytData(intStart) + (CLng(bytData(intStart + 1)) * 256)
End Function

'convert from a C++ float in a byte array to a single
Private Function BytesFloatToSingle(bytData() As Byte, ByVal intStart As Integer) As Single
    Dim sngData As Single
    
    Call CopyMemory(sngData, bytData(intStart), 4)
    
    BytesFloatToSingle = sngData
End Function

'convert from a C++ int in a byte array to a long
Private Function BytesIntToLong(bytData() As Byte, ByVal intStart As Integer) As Long
    Dim lngData As Long
    
    Call CopyMemory(lngData, bytData(intStart), 4)
    
    BytesIntToLong = lngData
End Function

'convert from a LFS MSHT (thousandths not included) to seconds
Private Function BytesMSHTToSeconds(bytData() As Byte, ByVal intStart As Integer) As Single
    Dim sngSeconds As Single

    sngSeconds = bytData(intStart) * 60                     'minutes
    sngSeconds = sngSeconds + bytData(intStart + 1)         'seconds
    sngSeconds = sngSeconds + (bytData(intStart + 2) / 100) 'hundreths

    BytesMSHTToSeconds = sngSeconds
End Function
