VERSION 5.00
Begin VB.UserControl okTabs 
   Alignable       =   -1  'True
   AutoRedraw      =   -1  'True
   ClientHeight    =   480
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4380
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForwardFocus    =   -1  'True
   ScaleHeight     =   32
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   292
   Begin VB.CheckBox chkTabs 
      Alignment       =   1  'Right Justify
      Height          =   255
      Index           =   0
      Left            =   75
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   90
      Visible         =   0   'False
      Width           =   255
   End
   Begin VB.PictureBox picTabs 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      FillColor       =   &H80000012&
      FontTransparent =   0   'False
      Height          =   300
      Index           =   0
      Left            =   75
      ScaleHeight     =   20
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   97
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   45
      Width           =   1455
   End
End
Attribute VB_Name = "okTabs"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'okTabs, a basic control to handle some tabs. These are not the API tabs in Windows but an "owner drawn"
'control using lines. Simple and efficient. The original example is on PSC somewhere but don't remember
'which one. Even though this uses essentially the same concept, it is totally rewritten and has a couple
'more (somewhat useless) features such as bold text when selected, background color and a checkbox on the
'left side. With a little more work you could add little icon support (just like the checkboxes) and a
'close button or two. If you do make a close button, create a label or button then change its font to
'Marlett and the caption to "r"

Option Explicit

Private m_intSelected As Integer        'index of the selected tab
Private m_intLeftOffset As Integer      'left position of 1st tab

Public Event Clicked(Index As Integer, Button As Integer)
Public Event DblClicked(Index As Integer)
Public Event Checked(Index As Integer, Checked As Boolean)

Public Function Add(Caption As String, Optional CheckBox As Boolean, _
                    Optional Color As Long = vbButtonText, Optional BGColor As Long = vbButtonFace) As Integer
    Dim intNew As Integer

    If picTabs(0).Tag = "" Then
        intNew = 0
    Else
        intNew = picTabs.UBound + 1

        Load picTabs(intNew)
        Load chkTabs(intNew)
    End If

    With picTabs(intNew)
        .Tag = Caption
        .ForeColor = Color
        .BackColor = BGColor
        .Visible = True
    End With
    
    chkTabs(intNew).BackColor = BGColor
    chkTabs(intNew).Visible = CheckBox
    
    Call Draw

    Add = intNew
End Function
Public Sub Remove(Index As Integer)
    Dim i As Integer

    'shift tabs down/left
    For i = Index To picTabs.UBound - 1
        picTabs(i).Tag = picTabs(i + 1).Tag
        picTabs(i).ForeColor = picTabs(i + 1).ForeColor
        picTabs(i).BackColor = picTabs(i + 1).BackColor
        picTabs(i).Enabled = picTabs(i + 1).Enabled

        chkTabs(i).Value = chkTabs(i + 1).Value
        chkTabs(i).BackColor = chkTabs(i + 1).BackColor
        chkTabs(i).Visible = chkTabs(i + 1).Visible
        chkTabs(i).Enabled = chkTabs(i + 1).Enabled
        chkTabs(i).Width = chkTabs(0).Width
    Next i

    'unload the last one
    If picTabs.UBound > 0 Then
        Unload picTabs(picTabs.UBound)
        Unload chkTabs(chkTabs.UBound)
    Else
        picTabs(0).Tag = ""
        chkTabs(0).Visible = False
        chkTabs(0).Value = 0
    End If

    Call Draw
End Sub

Public Property Get LeftOffset() As Integer
    LeftOffset = m_intLeftOffset
End Property
Public Property Let LeftOffset(intOffset As Integer)
    m_intLeftOffset = intOffset
    
    Call Draw
End Property

Public Property Get Enabled(Index As Integer) As Boolean
    Enabled = picTabs(Index).Enabled
End Property
Public Property Let Enabled(Index As Integer, blnEnabled As Boolean)
    picTabs(Index).Enabled = blnEnabled
    chkTabs(Index).Enabled = blnEnabled
    
    Call Draw
End Property

Public Property Get Checked(Index As Integer) As Boolean
    Checked = IIf(chkTabs(Index).Value = 0, False, True)
End Property
Public Property Let Checked(Index As Integer, blnChecked As Boolean)
    chkTabs(Index).Value = -blnChecked
End Property

Public Property Get Caption(Index As Integer) As String
    Caption = picTabs(Index).Tag
End Property
Public Property Let Caption(Index As Integer, strCaption As String)
    picTabs(Index).Tag = strCaption

    Call Draw
End Property

Public Property Get Count() As Integer
    Count = IIf(picTabs(0).Tag = "", 0, picTabs.Count)
End Property

Public Property Get hWnd() As Long
    hWnd = UserControl.hWnd
End Property

Public Sub ClickTab(Index As Integer)
    Call picTabs_MouseDown(Index, 1, 0, 0, 0)
End Sub

Public Sub Draw(Optional Index As Integer = -1)
    Dim i As Integer, xLeft As Integer, xWidth As Integer, yTop As Integer, yHeight As Integer
    
    On Error Resume Next
    
    If Index >= 0 Then m_intSelected = Index
    UserControl.Cls
    
    For i = 0 To picTabs.UBound
        With picTabs(i)
            If i = 0 Then xLeft = m_intLeftOffset
            If i > 0 Then xLeft = picTabs(i - 1).Left + picTabs(i - 1).ScaleWidth + 3

            .FontBold = True    'compute textwidth with bold so the width doesn't change depending on bold or not
            
            xWidth = .TextWidth(.Tag) + 20 + IIf(chkTabs(i).Visible, chkTabs(i).Width, 0)
            yTop = 4
            yHeight = UserControl.ScaleHeight - yTop - 2
            
            If i = m_intSelected Then
                xLeft = xLeft - 1
                xWidth = xWidth + 2
                yTop = 2
                yHeight = yHeight + 4
            End If
            
            Call .Move(xLeft, yTop, xWidth, yHeight)
            Call chkTabs(i).Move(xLeft, yTop + (.ScaleHeight - chkTabs(i).Height) \ 2)
            Call chkTabs(i).ZOrder
            
            .Cls
            .ForeColor = IIf(.Enabled, .ForeColor, vb3DShadow)
            .FontBold = (m_intSelected = i)
            .CurrentX = (xWidth + IIf(chkTabs(i).Visible, chkTabs(i).Width, 0) - .TextWidth(.Tag)) \ 2
            .CurrentY = (yHeight - .TextHeight(.Tag)) \ 2 - 1
            picTabs(i).Print .Tag
            
            'left
            UserControl.Line (xLeft - 2, yTop + yHeight - 1)-(xLeft - 2, yTop - 2), vb3DShadow
            UserControl.Line (xLeft - 1, yTop + yHeight - 1)-(xLeft - 1, yTop - 2), vb3DHighlight
            'top
            UserControl.Line (xLeft - 1, yTop - 2)-(xLeft + xWidth, yTop - 2), vb3DShadow
            UserControl.Line (xLeft, yTop - 1)-(xLeft + xWidth, yTop - 1), vb3DHighlight
            'right
            UserControl.Line (xLeft + xWidth, yTop - 1)-(xLeft + xWidth, yTop + yHeight), vb3DShadow
        End With
    Next i
    
    With picTabs(m_intSelected)
        yHeight = .Top + .Height - 2

        'draw the bottom lines, first from 0 to left of selected
        UserControl.Line (0, yHeight)-(.Left - 1, yHeight), vb3DShadow
        UserControl.Line (0, yHeight + 1)-(.Left, yHeight + 1), vb3DHighlight
        'finally from right of selected to end of control
        UserControl.Line (.Left + .Width, yHeight)-(UserControl.Width, yHeight), vb3DShadow
        UserControl.Line (.Left + .Width, yHeight + 1)-(UserControl.Width, yHeight + 1), vb3DHighlight
    End With
End Sub

Private Sub chkTabs_Click(Index As Integer)
    RaiseEvent Checked(Index, chkTabs(Index).Value)
End Sub

Private Sub picTabs_MouseDown(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    Call Draw(Index)
    RaiseEvent Clicked(Index, Button)
End Sub
Private Sub picTabs_DblClick(Index As Integer)
    Call Draw(Index)
    RaiseEvent DblClicked(Index)
End Sub

Private Sub picTabs_MouseMove(Index As Integer, Button As Integer, Shift As Integer, X As Single, Y As Single)
    UserControl.MousePointer = 0
End Sub
Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    UserControl.MousePointer = 0
End Sub

Private Sub UserControl_Resize()
    Call Draw
End Sub
Private Sub UserControl_Show()
    Call Draw
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    m_intLeftOffset = PropBag.ReadProperty("LeftOffset", 3)
End Sub
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    Call PropBag.WriteProperty("LeftOffset", m_intLeftOffset, 3)
End Sub
