VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "okTray"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_frmParent As Form
Private m_lngTrayID As Long

Private Const WM_APP As Long = &H8000&
Private Const WM_MYHOOK As Long = WM_APP + &H15

Private Const WM_MOUSEMOVE As Long = &H200

Private Const WM_LBUTTONDOWN As Long = &H201
Private Const WM_LBUTTONUP As Long = &H202
Private Const WM_LBUTTONDBLCLK As Long = &H203

Private Const WM_MBUTTONDOWN As Long = &H207
Private Const WM_MBUTTONUP As Long = &H208
Private Const WM_MBUTTONDBLCLK As Long = &H209

Private Const WM_RBUTTONDOWN As Long = &H204
Private Const WM_RBUTTONUP As Long = &H205
Private Const WM_RBUTTONDBLCLK As Long = &H206

Private Const WM_USER As Long = &H400
Private Const NIN_BALLOONSHOW = (WM_USER + 2)
Private Const NIN_BALLOONHIDE = (WM_USER + 3)
Private Const NIN_BALLOONTIMEOUT = (WM_USER + 4)
Private Const NIN_BALLOONUSERCLICK = (WM_USER + 5)

Private Const NOTIFYICON_VERSION = &H3

Private Const NIF_MESSAGE = &H1
Private Const NIF_ICON = &H2
Private Const NIF_TIP = &H4
Private Const NIF_STATE = &H8
Private Const NIF_INFO = &H10

Private Const NIM_ADD = &H0
Private Const NIM_MODIFY = &H1
Private Const NIM_DELETE = &H2
Private Const NIM_SETFOCUS = &H3
Private Const NIM_SETVERSION = &H4
Private Const NIM_VERSION = &H5

Private Const NIS_HIDDEN = &H1
Private Const NIS_SHAREDICON = &H2

'icon flags
Public Enum BalloonIcon
    NIIF_NONE = &H0
    NIIF_INFO = &H1
    NIIF_WARNING = &H2
    NIIF_ERROR = &H3
    NIIF_USER = &H4
End Enum
   
Private Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(7) As Byte
End Type

'http://msdn2.microsoft.com/en-us/library/ms538121.aspx
Private Type NOTIFYICONDATA
    cbSize As Long
    hWnd As Long
    uID As Long
    uFlags As Long
    uCallbackMessage As Long
    hIcon As Long
    szTip As String * 128
    dwState As Long
    dwStateMask As Long
    szInfo As String * 256
    uTimeoutAndVersion As Long
    szInfoTitle As String * 64
    dwInfoFlags As Long
    guidItem As GUID
End Type

Private Declare Function Shell_NotifyIcon Lib "shell32.dll" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, lpData As NOTIFYICONDATA) As Long

Public Event TrayMouseMove()
Public Event TrayClick(ByVal Button As Integer)
Public Event TrayDblClick(ByVal Button As Integer)
Public Event BalloonShown()
Public Event BalloonClicked()
Public Event BalloonClosed()

Public Sub TrayAdd(ParentForm As Form, ByVal Tip As String)
    Dim nID As NOTIFYICONDATA
   
    Set m_frmParent = ParentForm
    m_lngTrayID = CLng(Rnd * 998) + 1

    Call g_Subclass.SubclassWindow(m_frmParent.hWnd, Me)
    Call g_Subclass.SubclassMessage(m_frmParent.hWnd, WM_MYHOOK)
      
    With nID
        .cbSize = Len(nID)
        .hWnd = m_frmParent.hWnd
        .uID = m_lngTrayID
        .uFlags = NIF_MESSAGE Or NIF_ICON Or NIF_TIP
        .dwState = NIS_SHAREDICON
        .hIcon = m_frmParent.Icon
        .szTip = Tip & vbNullChar
        .uTimeoutAndVersion = NOTIFYICON_VERSION
        .uCallbackMessage = WM_MYHOOK
    End With
    Call Shell_NotifyIcon(NIM_ADD, nID)
End Sub
Public Sub TrayUpdate(bIcon As BalloonIcon, Optional ByVal Text As String, Optional ByVal Title As String, Optional TrayIcon As StdPicture)
    Dim nID As NOTIFYICONDATA
    
    With nID
        .cbSize = Len(nID)
        .hWnd = m_frmParent.hWnd
        .uID = m_lngTrayID
        .uFlags = NIF_INFO Or NIF_ICON
        .hIcon = IIf(TrayIcon Is Nothing, m_frmParent.Icon, TrayIcon)
        .dwInfoFlags = bIcon
        .szInfoTitle = Title & vbNullChar
        .szInfo = Text & vbNullChar
    End With
    Call Shell_NotifyIcon(NIM_MODIFY, nID)
End Sub
Public Sub TrayRemove()
    Dim nID As NOTIFYICONDATA
    
    With nID
        .cbSize = Len(nID)
        .hWnd = m_frmParent.hWnd
        .uID = m_lngTrayID
    End With
    Call Shell_NotifyIcon(NIM_DELETE, nID)
End Sub

'message handler, MUST be the last sub/function!!
Private Sub zWndProc1(ByVal bBefore As Boolean, ByRef bHandled As Boolean, ByRef lReturn As Long, _
                      ByVal lng_hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long, ByRef lParamUser As Long)
              
    If uMsg = WM_MYHOOK Then
        Select Case lParam
            Case WM_MOUSEMOVE
                RaiseEvent TrayMouseMove
            'Case WM_LBUTTONDOWN
            Case WM_LBUTTONUP
                RaiseEvent TrayClick(1)
            Case WM_LBUTTONDBLCLK
                RaiseEvent TrayDblClick(1)
            'Case WM_RBUTTONDOWN
            Case WM_RBUTTONUP
                RaiseEvent TrayClick(2)
            Case WM_RBUTTONDBLCLK
                RaiseEvent TrayDblClick(2)
            'Case WM_MBUTTONDOWN
            Case WM_MBUTTONUP
                RaiseEvent TrayClick(3)
            Case WM_MBUTTONDBLCLK
                RaiseEvent TrayDblClick(3)
            Case NIN_BALLOONSHOW
                RaiseEvent BalloonShown
            Case NIN_BALLOONHIDE
                RaiseEvent BalloonClosed
            Case NIN_BALLOONUSERCLICK
                RaiseEvent BalloonClicked
            Case NIN_BALLOONTIMEOUT
                RaiseEvent BalloonClosed
        End Select
    End If
End Sub

