Attribute VB_Name = "start"
Option Explicit

Public g_Subclass As New cSelfSub
Public g_InSim As New okInSimClient
Public g_HTTP As New okHTTPClient

'api for XP themes
Public Type tagInitCommonControlsEx
   lngSize As Long
   lngICC As Long
End Type

Public Const ICC_USEREX_CLASSES = &H200

Public Declare Function InitCommonControlsEx Lib "comctl32.dll" (iccex As tagInitCommonControlsEx) As Boolean

Public Sub Main()
    Dim iccex As tagInitCommonControlsEx

    iccex.lngSize = LenB(iccex)
    iccex.lngICC = ICC_USEREX_CLASSES
    InitCommonControlsEx iccex

    frmMain.Show
End Sub

'sticks any and all text into the main output/log
Public Sub Output(ByVal strMsg As String)
    Dim intFF As Integer
    
    With frmMain.txtOut
        .Text = .Text & "[" & Now & "] " & strMsg & vbNewLine
        .SelStart = Len(.Text)
    End With
    
    'and write a log..
    intFF = FreeFile
    Open App.Path & "\VB6_ISE.log" For Append As #intFF
        Print #intFF, "[" & Now & "] " & strMsg
    Close #intFF
End Sub


'- About?
'
'VB6_ISE is an open source project (written in Visual Basic 6 (not .NET)) for people messing with the Live for Speed InSim system.
'It is not a framework or library of any sort (I think) but it does do a nice job of wrapping up all InSim packets into a nice
'class and some user controls, making it much easier to work with. Other examples include an InSim gateway, a http browser
'XP themes, tabs, a list-view with icons, tray icon, etc.. Its just an example so not all things are thoroughly implemented.
'Error handling to name one. So please, take a look through the code and take what you like. If you have any improvements or
'need any help, please don't hesitate to post and ask. :)


'- Thanks to..
'
'Paul Caton, cSelfSub code, from: http://www.pscode.com/vb/scripts/ShowCode.asp?txtCodeId=64867&lngWId=1
'Carles PV, very nice API controls..
' ucListView: http://www.pscode.com/vb/scripts/ShowCode.asp?txtCodeId=56021&lngWId=1
' ucUpDownBox: http://www.pscode.com/vb/scripts/ShowCode.asp?txtCodeId=50379&lngWId=1
'Will Barden of the former WinsockVB.com, made it easy to understand Winsock stuff and some code in okSocket
'Steve McMahon, a few modern upgrades..
' high res/color icon: http://www.vbaccelerator.com/home/VB/Tips/Setting_the_App_Icon_Correctly/article.asp
' XP style: http://www.vbaccelerator.com/home/vb/code/Libraries/XP_Visual_Styles/Using_XP_Visual_Styles_in_VB/article.asp
'Karl E. Peterson, size grip, http://vb.mvps.org/samples/project.asp?id=grabber


'- "Some" info
'
'The most important class in this project is cSelfSub. It is my method to do subclassing, that is receive Window messages
'that VB6 does not receive natively. For example, okSocket subclasses to get socket messages (FD_CONNECT, FD_READ, ..),
'okTray gets tray messages (WM_LBUTTONUP, NIN_BALLOONSHOW, ..), and ucListView for its messages. You can see the message/callback
'handler at the bottom of those classes. At the bottom because it must be the last method in the class. See the methods
'in cSelfSub, or okSocket/okTray/ucListView, to see how it all works. The original ucListView also used a very similar method
'that was embedded into the control but along with a lot of other stuff in ucListView, it was taken out and/or tweaked by me.
'
'As mentioned, or if you have seen before, the okSocket class is my implementation of Windows sockets, aka Winsock 2.2. Yes, there
'are a ton of .ocx controls that already come with VB6 but those have their drawbacks. The main one is the winsock ocx has a known
'memory leak. Another is the need to distribute them, the space they take, the limitations, etc. API is the alternative and it
'works great. C/C++ uses the same method! The only thing you need to use this program is just that, the program. Everything else
'you already have, it came with Windows. So anyway, that's my take on VB6 and the API method. :)
'
'One thing that came out of this project is the gateway. It should be easy enough to use. Just listen on a certain port for an InSim
'program (just like LFS does when you type /insim) and it manages the traffic. The connecting program shouldn't know the difference. I've
'only tested it with LFS Stats, LFS Lapper and PitSpotter and they didn't know the difference so hopefully it will work. More work could go
'into it by handling the ISI flags properly, but this example is good for now. If you would like to upgrade it, feel free. That's the
'beauty of open source.
'
'Another spiffy feature is XP themes. The instructions on the site worked fine except I inserted the manifest file through the
'Visual C++ 6 resource editor. Insert > Custom.. > Resource type: 24 and the manifest file itself I pasted in and set then set to 1.
'The API that turns it "on" is above in Sub Main. If you want to see themes within the VB6 IDE, create a manifest file for your VB6.exe
'and stick it in the same folder. For me, the bad thing when giving VB6 a manifest is the color selection boxes, the color palettes won't
'show correctly. About the only other quirk I've experienced in the past is when radio buttons or checkboxes are placed on a frame control.
'The solution is to place them on a picture box control, then onto the frame, like I did with the OutGauge checkboxes. This was frustrating
'at first for me, so that's why I'm letting you know now.
'
'About the final two features are the tray class and the HTTP browser. The tray can manipulate the tray balloons easily. More
'than I used, and its a great way for server applications that run all the time. I didn't use much of the HTTP browser's potential
'but if you check out the comments in InSim_ConnectionNew event in okInSim, you can see a way to use it to query LFS world for stats
'stored there. With more knowledge of the HTTP protocol you could "easily" make a HTTPServer class so the program can serve web pages.
'I started to do this but it is nowhere near tested that much. If you would like what I have, please let me know..


'- File summary
'
'cSelfSub.cls               - Paul Caton, subclassing code + couple of my custom methods to subclass
'frmMain.frm                - the main window == modules + chat/log box
'frmMain.frx                - stuff in frmMain (not much)
'HighResIcon.bas            - Steve M, code to give a form a high color icon
'icons.res                  - resource file, holds any graphics or files needed
'LFS.bas                    - constants, enum, etc for okInSimClient
'mIOleInPlaceActivate.bas   - used by ucListView somehow..
'mListViewEx.bas            - same, used by ucListView
'okBrowser.ctl              - browser module
'okGateway.ctl              - gateway module
'okHTTPClient.cls           - my class to handle some basic http requests ( http://www.jmarshall.com/easy/http/  <-- helped! )
'okInSim.ctl                - InSim module, list, etc..
'okInSimClient.cls          - the goods, handles all things InSim
'okOutGauge.ctl             - OutGauge module, handles and displays InSim Dashboard packets
'okOutSim.ctl               - OutSim module, same as OutGauge but Car Position packets
'okSocket.cls               - class to handle winsock API
'okTabs.ctl                 - little control to handle tabs (w/ or w/o checkboxes?)
'okTray.cls                 - class to handle a tray icon
'OleGuids3.tlb              - type library used by ucListView
'start.bas                  - program entry point, global variables, this!
'ucListView.ctl             - Carles PV, API list view control
'ucUpDownBox.ctl            - Carles PV, the up/down control
'VB6_ISE.vbp                - main example VB project file
'VB6_ISE.vbw                - main emample workspace
